<?
/**
* select di $what da $table
*
* @param string sql        query sql da eseguire
*
* @param object connh      oggetto connessione adodb
*
* @return array row        ritorna l'array associativo della riga selezionata
*
*/
function select($sql, &$connh, $debug=true)
{

    $rs = $connh->Execute($sql);
    if (!$rs)
    {
        if ($debug) _error(array($query, $connh->ErrorMsg()));
        return false;
    }
    else return $rs;
}

/**
* insert dentro $table
*
* @param string table      nome della tabella
*
* @param array param       array associativo dei valori (le chiavi devono corrispondere ai nomi delle colonne)
*
* @param object connh      oggetto connessione adodb
*
* @return int lastid       Ritorna l'id della riga inserita
*
*/
function insert ($table, $param, &$connh, $debug=true)
{
    $query = "SELECT * FROM ".$table." WHERE id='-1'";
    $rs = $connh->Execute($query);

    $query = $connh->GetInsertSql($rs, $param, true);

    if (!$connh->Execute($query))
    {
        if ($debug) _error(array($query, $connh->ErrorMsg()));
        return false;
    }
    else return $connh->Insert_ID();
}

/**
* delete da una tabella
*
* @param string table      nome della tabella
*
* @param string where      condizione WHERE
*
* @param object connh      oggetto connessione adodb
*
* @return bool             ritorna true se la cancellazione va a buon fine
*/
function remove ($table, $where, &$connh, $debug=true)
{

    $query = "DELETE FROM " . $table . " WHERE " . $where;
    $rs = $connh->Execute($query);

    if (!$rs)
    {
        if ($debug) _error(array($query, $connh->ErrorMsg()));
        return false;
    }
    else return true;
}


/**
* update $table
*
* @param string table     nome della tabella
*
* @param int id           id della riga da aggiornare
*
* @param array param      array associativo dei valori (le chiavi devono corrispondere ai nomi delle colonne)
*
* @param object connh      oggetto connessione adodb
*
*/
function update ($table, $id, $param, &$connh, $debug=true)
{
    $query = "SELECT * FROM ".$table." WHERE id='".$id."'";
    $rs = $connh->Execute($query);

    $query = $connh->GetUpdateSql($rs, $param, true);

    if (!$connh->Execute($query))
    {
        if ($debug) _error(array($query, $connh->ErrorMsg()));
        return false;
    }
    else return true;
}

/**
* exists
*
* @param string table     nome della tabella
*
* @param int id           id della riga da controllare
*
* @param object connh      oggetto connessione adodb
*
*/
function exists ($table, $id, &$connh, $debug=true)
{
    $query = "SELECT * FROM ".$table." WHERE id='".$id."'";
    $rs = $connh->Execute($query);

    return $rs->RecordCount();
}

/**
* funzione di stampa errori
*
* @param array|string strings    array di messaggi stampati uno sotto l'altro o singola stringa
*
*/
function _error ($strings)
{
    if (is_array($strings)) foreach ($strings as $val) echo $val."<br>";
    else echo $strings;
}

?>
