<?php
/**
 * Header: $Id: session.php,v 1.11 2008/10/21 07:47:30 antonio Exp $
 *
 * @version $Revision: 1.11 $
 * @package DataHandler
 * @author  $Author: antonio $
 */


class Session extends DataHandler
{
    /**
     * List of var names currently registered
     *
     * @var array
     * @access  private
     */
    var $_registered_vars_list;

    /**
     * name of the session
     *
     * @var array
     * @access  public
     */
    var $session_name;

    /**
     * Constructs a new Session object.
     *
     * @param   string $session_name  The session name
     *
     * @access  public
     */
    function Session ($conf = array())
    {
        $this->session_name = $conf['session_name'];
        $this->_registered_vars_list = array();
        $this->register();
    }

    /**
     * Add new item item to the session
     *
     * @param   string  $itemname   itemname to register
     * @param   mixed   $item       item to add
     *
     * @access  public
     */
    function add ($itemname, $item)
    {
        $this->_registered_vars_list[$itemname] = $item;
        $this->register();
        return true;
    }

    /**
     * Remove an item from the session
     *
     * @param   string  $itemname   item name
     *
     * @access  public
     */
    function remove ($itemname)
    {
        unset($this->_registered_vars_list[$itemname]);
        $this->register();
        return true;
    }

    /**
     * Get the value of registered items in the session
     *
     * @param   string  $itemname   item name
     *
     * @access  public
     */
    function getvalue ($itemname)
    {
        if ($this->exists($itemname)) return $this->_registered_vars_list[$itemname];
        else return false;
    }

    /**
     * Test if an item is registered in the session
     *
     * @param   string  $itemname   item name
     *
     * @access  public
     */
    function exists ($itemname)
    {
        return isset($this->_registered_vars_list[$itemname]);
    }

    /**
     * Destroy a session object
     *
     *
     */
    function close ()
    {
        $this->_unregisterAll();
        session_destroy();
    }

    /**
    * register it self in the session
    *
    *
    * @access public
    */
    function register()
    {
        $_SESSION[$this->session_name] = $this;
    }

    /**
     * Unregister all variables currently registered
     *
     *
     * @access private
     */

    function _unregisterAll()
    {
        reset($this->_registered_vars_list);
        while (list($k, $v) = each($this->_registered_vars_list))
            if ($v)
            {
                unset($this->_registered_vars_list[$itemname]);
                //unset($_SESSION[$k]);
            }
        $this->register();
    }

} // class


?>